/*
 * A dynCalendar span of time
 * Defines spans of time with a [start, end] range
 */

//////////////////////////////////////////////////////////////////////////////
// Constructor
function dynCalendarSpan(id, group, start, end, period, comments) {
  if (dynCalendarSpan.arguments.length == 1) {
    // Copy constructor
    this.id = dynCalendarSpan.arguments[0].id;
    this.start = new Date(dynCalendarSpan.arguments[0].start);
    this.end = new Date(dynCalendarSpan.arguments[0].end);
    this.period = dynCalendarSpan.arguments[0].period;
    this.group = dynCalendarSpan.arguments[0].group;
    this.comments = dynCalendarSpan.arguments[0].comments;
  } else if (dynCalendarSpan.arguments.length == 6) {
    // Normal constructor
    this.id = id;
    this.start = start;
    this.end = end;
    this.period = period;
    this.group = group;
    this.comments = comments;
  }
}

//////////////////////////////////////////////////////////////////////////////
// Returns true if date is inside span (matches year, month and month day)
dynCalendarSpan.prototype.contains = function(date) {
  if (this.period == 0) {
    if (date.getFullYear() >= this.start.getFullYear() &&
        date.getFullYear() <= this.end.getFullYear()) {
      if (date.getMonth() >= this.start.getMonth() &&
          date.getMonth() <= this.end.getMonth()) {    
        if (date.getDate() >= this.start.getDate() &&
            date.getDate() <= this.end.getDate()) {
          return true;
        }
      }    
    }
  } else {
    return false;
  }

  return false;
}

//////////////////////////////////////////////////////////////////////////////
dynCalendarSpan.prototype.toString = function() {
  return this.id + ',' + 
         this.start.getDate() + '/' + this.start.getMonth() + '/' + this.start.getFullYear() + ',' + 
         this.end.getDate() + '/' + this.end.getMonth() + '/' + this.end.getFullYear() + ',' + 
         this.period + ',' + 
         this.group + ',' + 
         this.comments;
}
